// Package router ...
//
// Description : router ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2025-02-14 21:48
package router

import (
	"reflect"

	api_doc "git.zhangdeman.cn/gateway/api-doc"
	"git.zhangdeman.cn/gateway/api-doc/define"
)

func NewDoc(info *define.Info, servers []*define.ServerItem) *Doc {
	return &Doc{
		instance: api_doc.NewOpenapiDoc(info, servers),
	}
}

type Doc struct {
	instance *api_doc.Generate
}

// Add 增加接口文档测试
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 21:55 2025/2/14
func (d *Doc) Add(routePrefix string, paramType reflect.Type, resultType reflect.Type) {
	_ = d.instance.AddApiFromInAndOut(routePrefix, paramType, resultType)
}

// Data 文档数据
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 21:59 2025/2/14
func (d *Doc) Data() *define.OpenapiDoc {
	return d.instance.Doc()
}
